#include "stk_theme.h"
#include "../names.h"


void stkThemeButton( stkObject *object, int mouse_over ){
	int width, ascent, descent, state;
	float text_x, text_y, r,g,b, fw,fh;
	char *text;
	double clip_equation[] = {-1.0, 0.0, 0.0, 0.0};

	if(object->flags & STK_FLAGS_VISIBLE){
		glPushMatrix();

		state = object->flags & STK_FLAGS_BUTTON_PRESSED;

		if(object->flags & STK_FLAGS_COLOR){
			r = object->r;
			g = object->g;
			b = object->b;
		} else {
			r = 0;
			g = 0;
			b = 0;
		}

		text = object->BUTTON_TITLE;

		if(mouse_over){
			// draw highlighted button
			glColor3f(0.4f,0.5f,0.5f);
		} else {
			// draw normal button
			glColor3f(0.3f,0.4f,0.4f);
		}
		glBegin(GL_QUADS);
			glVertex2i(object->x, object->y);
			glVertex2i(object->x + object->w, object->y);
			glVertex2i(object->x + object->w, object->y + object->h);
			glVertex2i(object->x, object->y + object->h);
		glEnd();
		if(state) glColor3f(0.7, 0.7, 0.7);	// down border color 1
		else glColor3f(0.3, 0.3, 0.3);		// up
		glBegin(GL_LINES);
			glVertex2i(object->x, object->y);
			glVertex2i(object->x + object->w, object->y);
		glEnd();
		glBegin(GL_LINES);
			glVertex2i(object->x + object->w, object->y);
			glVertex2i(object->x + object->w, object->y + object->h);
		glEnd();
		if(state) glColor3f(0.3, 0.3, 0.3);	// down border color 2
		else glColor3f(0.7, 0.7, 0.7);		// up
		glBegin(GL_LINES);
			glVertex2i(object->x + object->w, object->y + object->h);
			glVertex2i(object->x, object->y + object->h);
		glEnd();
		glBegin(GL_LINES);
			glVertex2i(object->x, object->y + object->h);
			glVertex2i(object->x, object->y);
		glEnd();

		if(text != NULL){
			if((object->form->flags & STK_FLAGS_ENABLED) &&
			(object->flags & STK_FLAGS_ENABLED)){
				if(mouse_over){
					// highlighted text color
					glColor3f(r + 0.1,g + 0.1,b + 0.1);
				} else {
					// normal text color
					glColor3f(r,g,b);
				}
			} else {
				// disabled text color
				glColor3f(0.2f,0.2f,0.2f);
			}

			glEnable(GL_CLIP_PLANE0);
			clip_equation[3] = object->x + object->w;
			glClipPlane(GL_CLIP_PLANE0, clip_equation);

			fw = stk_theme_wr*(object->BUTTON_FONTSIZE);
			fh = stk_theme_hr*(object->BUTTON_FONTSIZE);

			txfGetStringMetrics(stk_theme_font, text, strlen(text),
						&width, &ascent, &descent);
			if(width > (object->w - 4)) text_x = object->x + 2;  
			else text_x = object->x + (object->w - width*fw)/2;
			text_y = object->y + (object->h - ascent*fh)/2;

			glEnable(GL_TEXTURE_2D);
			glAlphaFunc(GL_GEQUAL, 0.0625);
			glEnable(GL_ALPHA_TEST);
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glTranslatef(text_x, text_y, -0.1);
			glScalef(fw, fh, 0);
			txfRenderString(stk_theme_font, text, strlen(text));
			glDisable(GL_TEXTURE_2D);

			glDisable(GL_CLIP_PLANE0);
		}

		glPopMatrix();
	}
}
