#include "stk_theme.h"
#include "../names.h"
#include "tga.h"


TexFont *stk_theme_font;
GLuint *stk_theme_textures;
float stk_theme_wr, stk_theme_hr;


int stkThemeLoadTexture(char *filename){
        tgaInfo *textureImage;
        
        textureImage = tgaLoad(filename);
        if(textureImage->status){
                printf("WARNING: unable to load image file %s\n", filename);
                tgaDestroy(textureImage);
                return(0);
        }
        glTexImage2D(GL_TEXTURE_2D, 0, (textureImage->pixelDepth)>>3, textureImage->width,
                        textureImage->height, 0, textureImage->pixelDepth == 32 ? GL_RGBA : GL_RGB,
                        GL_UNSIGNED_BYTE, textureImage->imageData);  
        tgaDestroy(textureImage);
        return(1);
}


void stkThemeInit( ){
	stk_theme_wr = ((float)stk_window_w)/1000.0;
	stk_theme_hr = ((float)stk_window_h)/1000.0;

	stk_base_fontsize = STK_THEME_BASE_FONTSIZE;
	stkRenderForm = stkThemeForm;
	stkRenderObject[0] = stkThemeButton;
	stkRenderObject[1] = stkThemeToggleButton;
	stkRenderObject[2] = stkThemeInput;
	stkRenderObject[3] = stkThemeView;
	stkRenderObject[4] = stkThemeView;
	stkRenderObject[5] = stkThemeHScrollbar;
	stkRenderObject[6] = stkThemeVScrollbar;
	stkRenderObject[7] = stkThemeCheckbox;
	stkRenderObject[8] = stkThemeLabel;


	stk_theme_font = txfLoadFont("/usr/local/stk/default/lucidatypewriter18.txf");
	if (stk_theme_font == NULL) {
		printf("STK THEME ERROR: unable to load font, lucidatypewriter18.txf\n");
		exit(EXIT_FAILURE);
	}
	txfEstablishTexture(stk_theme_font, 0, GL_TRUE);

/*
	stk_theme_textures = (GLuint *)malloc(sizeof(GLuint)*STK_THEME_NR_TEXTURES);

	// load texture
	glBindTexture(GL_TEXTURE_2D, textures[STK_THEME_TEXTURE_???]);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	if(!stkThemeLoadTexture("/usr/local/stk/default/???.tga")){
		printf("STK THEME ERROR: unable to load required texture\n");
		exit(EXIT_FAILURE);
	}
*/
}
