#include "stk_theme.h"
#include "../names.h"


void stkThemeInput( stkObject *object, int mouse_over ){
	int width, ascent, descent, cursor;
	float text_x, text_y, r,g,b, fw,fh, a;
	char *text;
	double clip_equation[] = {-1.0, 0.0, 0.0, 0.0};  

	if(object->flags & STK_FLAGS_VISIBLE){
		glPushMatrix();

		text = object->INPUT_TEXT;

		if(mouse_over || (stk_input_with_focus == object)){
			// draw highlighted input
			glColor3f(0.4, 0.5, 0.5);
		} else {
			// draw normal input
			glColor3f(0.3, 0.4, 0.4);
		}
		glBegin(GL_QUADS);
			glVertex2i(object->x, object->y);
			glVertex2i(object->x + object->w, object->y);
			glVertex2i(object->x + object->w, object->y + object->h);
			glVertex2i(object->x, object->y + object->h);
		glEnd();

		glColor3f(0.7, 0.7, 0.7);
		glBegin(GL_LINES);
			glVertex2i(object->x, object->y);
			glVertex2i(object->x + object->w, object->y);
		glEnd();
		glBegin(GL_LINES);
			glVertex2i(object->x + object->w, object->y);
			glVertex2i(object->x + object->w, object->y + object->h);
		glEnd();
		glColor3f(0.3, 0.3, 0.3);
		glBegin(GL_LINES);
			glVertex2i(object->x + object->w, object->y + object->h);
			glVertex2i(object->x, object->y + object->h);
		glEnd();
		glBegin(GL_LINES);
			glVertex2i(object->x, object->y + object->h);
			glVertex2i(object->x, object->y);
		glEnd();

		if(text != NULL){
			if(object->flags & STK_FLAGS_COLOR){
				r = object->r;
				g = object->g;
				b = object->b;
			} else {
				r = 0;
				g = 0;
				b = 0;
			}
			if((object->form->flags & STK_FLAGS_ENABLED) ||
			(object->flags & STK_FLAGS_ENABLED)){
				if(mouse_over){
					// highlighted text color
					glColor3f(r + 0.1, g + 0.1, b + 0.1);
				} else {
					// normal text color
					glColor3f(r,g,b);
				}
			} else {
				// disabled text color
				glColor3f(0.2f,0.2f,0.2f);
			}

			glEnable(GL_CLIP_PLANE0);
			clip_equation[3] = object->x + object->w;
			glClipPlane(GL_CLIP_PLANE0, clip_equation);

			fw = stk_theme_wr*(object->INPUT_FONTSIZE);
			fh = stk_theme_hr*(object->INPUT_FONTSIZE);

			if(stk_input_with_focus == object){
				cursor = stk_input_cursor;
				text = &text[stk_input_left];
				txfGetStringMetrics(stk_theme_font, text, cursor - stk_input_left,
							&width, &ascent, &descent);
printf("WIDTH=%f ow=%d\n", width*fw, object->w);
				if(width*fw > (object->w - 4)){
					stk_input_left++;
					text++;
				}
			} else {
				cursor = 0;
			}
			txfGetStringMetrics(stk_theme_font, text, strlen(text),
						&width, &ascent, &descent);
			text_x = object->x + 2;
			text_y = object->y + (object->h - ascent*fh)/2;

			glEnable(GL_TEXTURE_2D);
			glAlphaFunc(GL_GEQUAL, 0.0625);
			glEnable(GL_ALPHA_TEST);
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glTranslatef(text_x, text_y, 0);
			glScalef(fw, fh, 0);
			txfRenderString(stk_theme_font, text, strlen(text));
			glDisable(GL_TEXTURE_2D);
			glPopMatrix();
			glPushMatrix();

			txfGetStringMetrics(stk_theme_font, text, cursor - stk_input_left,
				&width, &ascent, &descent);
			a = ascent*fh;
			glTranslatef(text_x + width*fw - 1, text_y, 0);
			glColor3f(0, 0, 1);
			glBegin(GL_QUADS);
				glVertex2f(0, 0);
				glVertex2f(0, a);
				glVertex2f(2, a);
				glVertex2f(2, 0);
			glEnd();

			glDisable(GL_CLIP_PLANE0);
		}

		glPopMatrix();
	}
}
