#include "stk.h"
#include "names.h"


stkObject *stk_input_with_focus;
int stk_input_cursor, stk_input_left, stk_input_highlight;


stkObject *stkCreateInput ( stkForm *form, int x, int y, int w, int h,
			void (*change)(char *text), char *text,
			int max_size, float fontsize ){
	stkObject *object;
	int length;

	object = stkCreateObject(STK_INPUT, form, x,y,w,h, __INPUT_SIZE);
	if(object != NULL){
		object->INPUT_CHANGE = change;
		object->INPUT_FONTSIZE = fontsize*stk_base_fontsize;

		length = strlen(text);

		if(max_size){
			object->INPUT_MAXSIZE = max_size;
			if(length > max_size) text[max_size] = '\0';
		} else {
			object->INPUT_MAXSIZE = length;
			object->flags |= (char)STK_FLAGS_INPUT_RESIZE;
		}
		object->INPUT_TEXT = (char *)malloc(object->INPUT_MAXSIZE + 1);
		strcpy(object->INPUT_TEXT, text);
	}
	return(object);
}


char *stkGetInput( stkObject *object ){
	if(object != NULL) return(object->INPUT_TEXT);
	else return(NULL);
}


void stkSetInput( stkObject *object, char *text ){
	int length;

	if(object != NULL){
		free(object->INPUT_TEXT);

		length = strlen(text);

		if(object->flags & STK_FLAGS_INPUT_RESIZE){
			object->INPUT_MAXSIZE = length;
		} else {
			if(length > object->INPUT_MAXSIZE) text[object->INPUT_MAXSIZE] = '\0';
		}
		object->INPUT_TEXT = (char *)malloc(object->INPUT_MAXSIZE + 1);
		strcpy(object->INPUT_TEXT, text);
	}
}


void stkClearInput( stkObject *object ){
	if(object != NULL){
		free(object->INPUT_TEXT);
		object->INPUT_TEXT = NULL;
	}
}
