#include "stk.h"
#include "names.h"


stkObject *stkCreateHScrollbar( stkForm *form, int x, int y, int w, int h,
				void (*change)(int value), int left,
				int right, int value ){
	stkObject *object;

	object = stkCreateObject(STK_HSCROLLBAR, form, x,y,w,h, __SCROLLBAR_SIZE);
	if(object != NULL){
		object->SCROLLBAR_CHANGE = change;
		object->SCROLLBAR_MIN = left;
		object->SCROLLBAR_MAX = right;
		object->SCROLLBAR_VALUE = value;
	}
	return(object);
}


stkObject *stkCreateVScrollbar( stkForm *form, int x, int y, int w, int h,
				void (*change)(int value), int top,
				int bottom, int value ){
	stkObject *object;

	object = stkCreateObject(STK_VSCROLLBAR, form, x,y,w,h, __SCROLLBAR_SIZE);
	if(object != NULL){
		object->SCROLLBAR_CHANGE = change;
		object->SCROLLBAR_MIN = top;
		object->SCROLLBAR_MAX = bottom;
		object->SCROLLBAR_VALUE = value;
	}
	return(object);
}


int stkGetScrollbar( stkObject *object ){
	if(object != NULL) return(object->SCROLLBAR_VALUE);
	else return(-1);
}


void stkSetScrollbar( stkObject *object, int value ){
	if(object != NULL) object->SCROLLBAR_VALUE = value;
}
